$APPTYPE GUI: $TYPECHECK ON

'$X11
 
$IFNDEF X11
  $RESOURCE man_files as "hbmanual.dat"
  $INCLUDE "xptitle.inc"
$ELSE
  $RESOURCE man_files as "hbxman.dat"
$ENDIF

$INCLUDE "httphelp.inc"

'Note: .len is a shorter, faster version of .length

dim http as httphelp, www as date
defint64 www64,doc64  'FILETIMEs
http.Host="mypages.cwdom.dm"

defint i,j,k,n,r,s
defstr paths,file$,IP$,res$,dat
defint Adat=objptr(dat)
defstr help1$=command$(1)  'path to Help Directory trailing \
if not help1$.len then
  dat.additems "No Help Directory."
$IFNDEF X11
  dat.additems "Usage:","hbmanual <path with trailing \>"
$ELSE
  dat.additems "Usage:","hbmanual <path with trailing />"
$ENDIF
  showmessage dat
  app.terminate
end if
defstr help$=left$(help1$,help1$.len-one)

declare sub lb_item (i$ as STRING)

create f As FORM
  width=300: height=224
  caption="HotBasic Manual Update 1.2"
  icon="hotbasic.ico"
  resizeable=false
  minimizebox=false
  maximizebox=false
  center
  onclose=no_close  'prevent manual exit
  create e as edit
    left=zero: top=zero
    width=f.clientwidth-100
    color=&HCCFFFF
    text=help1$
  end create
  create g as gauge
    left=e.width+one: top=zero
    width=100: height=20
    position=zero
    forecolor=&HA000A0 'Purple
  end create
  create lb as listbox
    left=zero: top=20
    width=f.clientwidth: height=160
  end create
  create SB as statusbar
  end create
end create

$IFDEF X11
lb.height=182
$ELSE
lb_item byref$(@WSAStart+4)  'show wsock version
f.height=f.height+xptitle
$ENDIF

f.show

'help directory
if direxists(help$) then
  lb_item help$+" directory found"
else
  mkdir help$
  lb_item help$+" directory created"
  lb_item "Download manual and unzip"
  lb_item "into this Help Directory."
  goto manual_exit
end if

paths.extractres "man_files"  'get manual file list
n=paths.itemcount
lb_item str$(n)+" files found"

paths.position=zero
lb_item "Checking for newer files..."
for i=1 to n
file$=paths.readline

SB.text=file$: doevents
res$="/keenej/hot/"+file$
'lb_item res$
http.Command="HEAD": r=http.Header(res$,Adat)
if not r then goto error1
doevents
www.Day=http.Day: www.Month=http.Month: www.Year=http.Year
www.saveint64 www64  'www FILETIME
r=fileexists(help1$+file$)  'generate FILEREC data
memcpy @doc64,@hbFILEREC+20,8  'doc FILETIME
if www64>doc64 then
  r=http.Download(res$,Adat)
  lb_item http.LastModified
  if r then
    dat.savetofile help1$+file$: dat=null
    lb_item file$+" updated"
  else
    lb_item file$+" download failed"
  end if
end if
g.position=100*i/n

next i
goto manual_exit

error1:
lb_item http.Error: goto manual_exit

manual_exit:
lb_item null
lb_item "Please review log and exit program."
lb.savetofile path$+"hbmanual.log"
f.onclose=zero  'note how we "turn off" an event routine
lb.focus
sleep 3
'f.showmodal
END

sub lb_item
lb.additems i$
lb.itemindex=lb.itemcount-one
doevents
end sub

no_close:
return
